function teeOlki(){
    var geometry = new THREE.CylinderGeometry( 0.03, 0.03, 1 );
    var material = new THREE.MeshPhongMaterial( { color: 0xffcc00 } );
    var cube = new THREE.Mesh( geometry, material );
    return cube;
}

function teeHimmeliKolmio(){
    var olkiA = teeOlki();
    var olkiB = teeOlki();
    var olkiC = teeOlki();

    olkiB.translateY(-.5);
    olkiB.rotateZ(4*Math.PI/3);
    olkiB.translateY(-.5);

    olkiC.translateY(.5);
    olkiC.rotateZ(-4*Math.PI/3);
    olkiC.translateY(.5);

    var himmeli = new THREE.Group();
    himmeli.add( olkiA );
    himmeli.add( olkiB )
    himmeli.add( olkiC )
    return himmeli;
}

function teeHimmeli(n){
    var himmeli = new THREE.Group();

    for (var i=0;i<n;i++){
	var kolmio = teeHimmeliKolmio();
	kolmio.rotateY(2*Math.PI/n*i);
	himmeli.add(kolmio);
    }
    return himmeli;
}

var scene = new THREE.Scene();
var camera = new THREE.PerspectiveCamera( 75, window.innerWidth / window.innerHeight, 0.1, 1000 );

var renderer = new THREE.WebGLRenderer();
renderer.setSize( window.innerWidth, window.innerHeight );
document.body.appendChild( renderer.domElement );


var himmeli = teeHimmeli(13);

var himmeli2 = teeHimmeli(7);

scene.add( himmeli );
scene.add( himmeli2 );



/*
var geometry = new THREE.CylinderGeometry();
var material = new THREE.MeshBasicMaterial( {color: 0xffff00} );
var cylinder = new THREE.Mesh( geometry, material );
scene.add( cylinder );
*/

// White directional light at half intensity shining from the top.
var directionalLight = new THREE.DirectionalLight( 0xffffff, 0.5 );
scene.add( directionalLight );

var light = new THREE.AmbientLight( 0x404040 ); // soft white light
scene.add( light );


camera.position.z = 2;


function animate() {
    requestAnimationFrame( animate );
    // (Huom: Oikeassa tuotoksessa pitää ottaa nykyinen ajankohta jostain kellosta,
    // koska näytönpäivityksen nopeus riippuu laitteistosta.)

    himmeli.rotation.x += 0.01;
    himmeli.rotation.z += 0.01;
    himmeli2.rotation.y += 0.01;

    renderer.render( scene, camera );
}


// Initialize music generation (player).
var player = new CPlayer();
player.init(song);

while(player.generate() <1){};
var wave = player.createWave();
var audio = document.createElement("audio");
audio.src = URL.createObjectURL(new Blob([wave], {type: "audio/wav"}));
audio.play();

animate();
